#-------------------------------------------------------------------------
# all modules that do things that must be disabled during testing,
# such as sending mail, making entries in the remedy database, incorporating
# mh mail, and so on use the debug level stored here to determine how to
# behave.
#
# level		behaviour
# -------	-------------
# 0			normal - no debugging
# 1-9		verbosity levels
# >= 10		debug. no destructive action (no mails, no changes to DB, etc)
#-------------------------------------------------------------------------
package Debug;

BEGIN {
	#print "this is Debug\n";
	#$Debug::level = 10;
	$Debug::level = 7;
	$Debug::verbosity = 10;
	$ENV{'DOMADMDEBUGLEV'} = $Debug::level;
}

sub Level() {
	$Debug::level;
}

sub verbosity
{
	$Debug::verbosity;
}

sub setLevel
{
	my $level = shift;
	$Debug::level = $level;
}

1;
